<script lang="ts">
import type {
  Pixel, Rect, Second, Unit,
} from '@/data';
import {
  Component, Prop, Watch,
} from 'vue-property-decorator';
import CanvasTimelineGeneric from './CanvasTimelineGeneric.vue';

@Component
export default class CanvasTimelineDate extends CanvasTimelineGeneric {
  declare y: number;

  declare width: Pixel;

  declare zoom: number;

  declare pixelUnit: Unit<Pixel>;

  declare viewRect: Rect;

  @Prop({ required: true })
  secondUnit!: Unit<Second>;

  TIMELINE_PADDING = 50;

  VISIBLE_MARKER = 6;

  BASE_INTERVAL = 5;

  timeMarkers: Array<{position: Pixel, label: string}> = [];

  end: Pixel = 0 as Pixel;

  interval = 1;

  @Watch('width')
  @Watch('viewRect.width')
  calculateVisibleInterval() {
    const musicalInterval = this.pixelUnit
      .toInterval(this.viewRect.x, this.viewRect.x + this.viewRect.width as Pixel);
    const interval = this.secondUnit.fromInterval(musicalInterval.onset, musicalInterval.duration);
    this.interval = Math
      .ceil(interval.width / this.VISIBLE_MARKER);

    // Round interval to a multiple of BASE_INTERVAL
    this.interval = this.BASE_INTERVAL
      * Math.max(1, Math.round(this.interval / this.BASE_INTERVAL));

    this.calculatePositions(this.width);
  }

  @Watch('width')
  calculatePositions(newWidth: Pixel) {
    this.end = newWidth;
    const lastOnset = this.pixelUnit.toOnset(this.width).value;
    const lastSecond = this.secondUnit.fromOnset(lastOnset).value;
    const newMarkers = [];
    for (let i = 0; i < lastSecond; i += 1) {
      newMarkers.push({
        position: this.pixelUnit.fromOnset(this.secondUnit.toOnset(i as Second).value).value,
        label: (i % this.interval === 0) ? this.formatDate(i) : '·',
      });
    }
    this.timeMarkers = [...newMarkers];
  }

  formatDate(date: number): string {
    const seconds = new Date(0);
    seconds.setSeconds(date);
    const secondsString = `${seconds.getSeconds()}`.padStart(2, '0');
    return `${seconds.getMinutes()}:${secondsString}`;
  }

  mounted() {
    this.calculateVisibleInterval();
  }
}
</script>
